add_theory(r).

abbreviation A \= B === not(A = B).

constant true.
constant false.
function if(_,_,_).
function 700 nonassoc '='(_,_).
quantifier(all).

primf(:,650,xfx).


function 830 rightassoc '=>'(A,B)
=== if(A, if(B, true, false), true).

function 810 rightassoc 'and'(A,B)
=== if(A, if(B, true, false), false).

function 840 rightassoc '<=>'(A, B)
=== (A => B) and (B => A).


axiom true
=== true.

axiom iftrue
=== if(true, A, B) = A.

axiom iffalse
=== if(false, A, B) = B.

axiom ifparallel
=== if(A, B, B) = B.

axiom reflexeql 
=== (A = A).

axiom symmeql  
=== ((A = B) => (B = A)).

axiom transeql 
=== (A = B) and (B = C) => (A = C).

is_equivalence(=).

/*
** Can't be proven by window inference as window inference
** has 'prior knowledge' of the properties of '<=>'
*/

postulate refleximp
===  A => A.

postulate transimp
===  ((A => B) and (B => C)) => (A => C).

is_preorder(=>).

%%  Necessary for trans_true in equality

postulate impeqltrue
===  A => (A = true).



postulate reflexeqv
===  A <=> A.

postulate transeqv
===  ((A <=> B) and (B <=> C)) => (A <=> C).

postulate symmeqv
===  (C <=> A) => (A <=> C).

postulate eqvimpimp
===  (C <=> A) => (C => A).


is_equivalence(<=>).
is_stronger_than(<=>, =>).


postulate eqlimpeqv
=== (A = B) => (A <=> B).


is_stronger_than(=, <=>).


function 800 prefix (not A) 
=== (A <=> false).

function 820 leftassoc or(A,B)
=== (not A => B).

function bool(A)
=== ((A = true) or (A = false)).



obj_var(y).

quantifier(ex,x,A)       
=== not (all x not A).

quantifier(l_local,x,A) 
=== (all x (all y  y = x => (A <=> [y/x]*A))).

quantifier(is_local,x,A) 
=== (all x (all y  y = x => (A = [y/x]*A))).

quantifier(strong_is_local,x,A)
=== (all x (all y  y <=> x => (A = [y/x]*A))).



axiom eqlbool
=== bool(A = B).

axiom mkinstall 
=== (all x A) 
   = (([New/x]*A) 
     and (all x A)).

postulate mkinstall2
=== (all x A) 
    => [New/x]*A.

axiom alltrue
=== all x true.



/*
**  Once again, not all of the opening rules in this theory 
**  need be primitive, but at present
**  we are constrained in what we can do about it.
*/


/*
** These opening rules for if encode the excluded middle.
*/

openrule(if(A, B, C), [1],
	 [not(B <=> C)],
	 id,
	 [<=> --> <=>],
	 [B --> true, C --> false, if(G,_,_) --> G]).

openrule(if(A, B, C), [1],
         [not(B = C)],
	 id,
	 [= --> <=>],
	 [B --> true, C --> false, if(G,_,_) --> G]).

openrule(if(A, B, C), [2],
	 [A],
	 id,
	 [=> --> =>, <=> --> <=>, = --> =],
	 [if(_,G,_) --> G, id]).

openrule(if(A, B, C), [3],
	 [not A], 
	 id, 
	 [=> --> =>, <=> --> <=>, = --> =],
	 [if(_,_,G) --> G, id]).






q_rerun(r : true_imp_if).
q_rerun(r : if_imp).
q_rerun(r : if_true_false).
q_rerun(r : trueimp).
q_rerun(r : imp_true).
% q_rerun(r : refleximp).
q_rerun(r : trueand).


openrule(A => B,  [2], [A],     id, [=> --> =>, = --> <=>], [A => D --> D, id]).
openrule(A and B, [1], [B],     id, [=> --> =>, = --> <=>], id).
openrule(A and B, [2], [A],     id, [=> --> =>, = --> <=>],  id).
openrule(A = B,   [1], [],      id, [= --> =], [C = D --> C, true --> B]).
openrule(A = B,   [2], [],      id, [= --> =], [C = D --> D, true --> A]).
openrule(A <=> B, [1], [],      id, [= --> <=>], [C <=> D --> C, true --> B]).
openrule(A <=> B, [2], [],      id, [= --> <=>], [C <=> D --> D, true --> A]).
openrule(all x A, [b(x)], [],   id, [=> --> =>, = --> <=>], id).
openrule(ex x A,  [b(x)], [],   id, [=> --> =>, = --> <=>], id).
openrule(not A,   [1],
	 [],
	 id,
	 [=> --> rev(=>), = --> <=>],  
	 [ true  --> false,
	   false --> true,
	   not D --> D,
	   D     --> not D]).

openrule(A => B,  [1], 
	 [not B], 
	 id, 
	 [=> --> rev(=>), = --> <=>],  
	 [ C => D --> C, 
	   true   --> false, 
	   false  --> true, 
	   not C  --> C, 
	   C      --> not C]).

openrule(A or B,  [1], [not B], id, [=> --> =>, = --> <=>], [C or D --> C, id]).
openrule(A or B,  [2], [not A], id, [=> --> =>, = --> <=>],  [D or C --> C, id]).
openrule(bool(A), [1], [],      id, [= --> =],  [bool(B) --> B]).

openrule(l_local  x A, [b(x)], [], id, [= --> <=>], []).
openrule(is_local x A, [b(x)], [], id, [= --> =],   []).

openrule(V:T, [1], [], id, [= --> =], []).
openrule(V:T, [2], [], id, [= --> =], []).

q_rerun(r : back_thm).
q_rerun(r : back_thm1).
q_rerun(r : back_thm2).
q_rerun(r : back_thm3).
q_rerun(r : back_thm4).
q_rerun(r : andtrue).
q_rerun(r : falseand).
q_rerun(r : affirmf).
q_rerun(r : nottrue).
q_rerun(r : symeqv).
q_rerun(r : trueeqv).
rerun(r : eqv_true).
q_rerun(r : eqvtrue).

% q_rerun(r : eqvimpimp).

back_theorem(t, <=>, r:back_thm).
back_theorem(f, =,   r:back_thm1).
back_theorem(r, =,   r:back_thm2).
back_theorem(r, <=>, r:back_thm3).
back_theorem(f, <=>, r:back_thm4).

q_rerun(r : symand).
q_rerun(r : symeql).
q_rerun(r : eqltrue).
q_rerun(r : trueeql).
q_rerun(r : mpdeduce).
q_rerun(r : install).
q_rerun(r : falseimp).
q_rerun(r : not).
q_rerun(r : andfalse).
q_rerun(r : notfalse).
q_rerun(r : notfalseax).
q_rerun(r : imp_then).
q_rerun(r : imp_else).
q_rerun(r : true_ineqv_false).
q_rerun(r : notnot).
q_rerun(r : ifif).
q_rerun(r : or_parallel).
rerun(r : all_dist_and).
q_rerun(r : all_dist_and_r).
q_rerun(r : all_dist_and_l).
q_rerun(r : impfalse).
rerun(r : caseor).
q_rerun(r : ornot).
rerun(r : case).
q_rerun(r : andnot).
q_rerun(r : notand).
q_rerun(r : allfalse).
q_rerun(r : mp).
q_rerun(r : notor).
q_rerun(r : orparallel).
rerun(r : antecedents).
q_rerun(r : strengthen).
q_rerun(r : strengthen2).
q_rerun(r : ortrue).
q_rerun(r : trueor).
q_rerun(r : falseor).
q_rerun(r : notif).
q_rerun(r : splitimp).
q_rerun(r : def_imp).
q_rerun(r : symor).
q_rerun(r : orfalse).
q_rerun(r : exfalse).
q_rerun(r : extrue).
q_rerun(r : booltrue).
q_rerun(r : boolfalse).
q_rerun(r : deMorganor).
q_rerun(r : deMorganand).  %% May need to go later?
q_rerun(r : notimpbool).
rerun(r : eqvimpeql).
q_rerun(r : impnotbool).
q_rerun(r : notbool).

rule_group(simp_if, refleximp, t).
rule_group(simp_if, reflexeql, t).
rule_group(simp_if, reflexeqv, t).
rule_group(simp_if, trueand, f).
rule_group(simp_if, andtrue, f).
rule_group(simp_if, trueimp, f).
rule_group(simp_if, imp_true, t).
rule_group(simp_if, ifparallel, f).
rule_group(simp_if, iftrue, f).
rule_group(simp_if, iffalse, f).
rule_group(simp_if, eqvtrue, f).
rule_group(simp_if, trueeqv, f).

rule_group(refleximp, t).
rule_group(reflexeql, t).
rule_group(reflexeqv, t).
rule_group(trueand, f).
rule_group(andtrue, f).
rule_group(trueimp, f).
rule_group(imp_true, t).
rule_group(ifparallel, f).
rule_group(iftrue, f).
rule_group(iffalse, f).
rule_group(eqvtrue, f).
rule_group(trueeqv, f).
rule_group(nottrue, f).
rule_group(falseimp, t).
rule_group(notfalse, f).
rule_group(notnot, f).
rule_group(alltrue, t).
rule_group(impfalse, f).
rule_group(falseand, f).
rule_group(affirmf, f).
rule_group(eqltrue, f).
rule_group(trueeql, f).
rule_group(andfalse, f).
rule_group(def(not), r).
rule_group(or_parallel, f).
rule_group(trueor, f).
rule_group(ortrue, f).
rule_group(orfalse, f).
rule_group(falseor, f).
rule_group(notor, t).
rule_group(ornot, t).
rule_group(notand, f).
rule_group(andnot, f).
rule_group(allfalse, f).
rule_group(exfalse, f).
rule_group(extrue, t).
rule_group(booltrue, t).
rule_group(boolfalse, t).


add_tactic(std_heur).
add_tactic(conj).
add_tactic(back).
add_tactic(tactics).
add_tactic(mark1).
add_tactic(forwards).
add_tactic(quant).
add_tactic(rewrite).
add_tactic(prinz).


macro('r_plus.thy').
add_tactic(prop_auto).
add_tactic(localness).
