postulate islocalimpllocal
=== (is_local x_1 A)
    => (l_local x_1 A).

postulate reflexlocal
=== (is_local x_1 x_1).

postulate indeplocal
=== (is_local x_1 A) :- x_1 not_free_in A.

postulate localimp
=== (l_local x_1 A) and (l_local x_1 B)
    => (is_local x_1 A => B).

postulate localnot
=== (l_local x_1 A)
    => (is_local x_1 not A).

postulate localand
=== (l_local x_1 A) and (l_local x_1 B)
    => (is_local x_1 A and B).

postulate localor
=== (l_local x_1 A) and (l_local x_1 B)
    => (is_local x_1 A or B).

postulate localeqv
=== (l_local x_1 A) and (l_local x_1 B)
    => (is_local x_1 A <=> B).

postulate localeql
=== (is_local x_1 A) and (is_local x_1 B)
    => (is_local x_1 A = B).

postulate localif
=== (l_local x_1 A) and ((is_local x_1 B) and (is_local x_1 C))
    => (is_local x_1 if(A, B, C)).

postulate localall
=== (l_local x_1 A) 
    => (is_local x_1 (all x_2 A)).

postulate localex
=== (l_local x_1 A)
    => (is_local x_1 (ex x_2 A)).

postulate local_typing
=== (is_local x A) and (is_local x T)
    => (is_local x A:T).


rule_group(localness, r:reflexlocal, t).
rule_group(localness, r:localimp, r).
rule_group(localness, r:localand, r).
rule_group(localness, r:localor, r).
rule_group(localness, r:localnot, r).
rule_group(localness, r:localeql, r).
rule_group(localness, r:localeqv, r).
rule_group(localness, r:localall, r).
rule_group(localness, r:localex, r).
rule_group(localness, r:localif, r).
rule_group(localness, r:local_typing, r).
rule_group(localness, r:indeplocal, t).
rule_group(localness, r:islocalimpllocal, r).

% theorem r:local_substitutivity ===
%     (is_local y Z) and A=B => [A/y]*Z = [B/y]*Z.
% [2].
% h 1.
% use(def(is_local)).
% use(mkinstall2).
% use(mkinstall2).
% use(h A=B) on_focus [1].
% quit.
% use(h 4) on_focus [1].
% quit.
% quit.
rerun(r:local_substitutivity).

postulate impbool === bool(A => B).
postulate andbool === bool(A and B).
postulate orbool  === bool(A or B).
postulate eqvbool === bool(A <=> B).
postulate allbool === bool(all x_1 A).
postulate exbool  === bool(ex x_1 A).
postulate booleq  === bool(A) and bool(B) => (A <=> B) = (A = B).

postulate iflocalprop
=== (is_local x_1 A) 
    => [if(B, C, D)/x_1]*A = if(B, [C/x_1]*A, [D/x_1]*A).

postulate ifimp === (if(A, B, C) => D) = if(A, B => D, C => D).
postulate impif === (A => if(B, C, D)) = if(B, A => C, A => D).
postulate ifand === (if(A, B, C) and D) = if(A, B and D, C and D).
postulate andif === (A and if(B, C, D)) = if(B, A and C, A and D).
postulate ifeqv === (if(A, B, C) <=> D) = if(A, B <=> D, C <=> D).
postulate eqvif === (A <=> if(B, C, D)) = if(B, A <=> C, A <=> D).
postulate ifeql === (if(A, B, C) = D) = if(A, B = D, C = D).
postulate eqlif === (A = if(B, C, D)) = if(B, A = C, A = D).
postulate ifor  === (if(A, B, C) or D) = if(A, B or D, C or D).
postulate orif  === (A or if(B, C, D)) = if(B, A or C, A or D).

% mkaxiom(notif, (not if(A, B, C)) = if(A, not B, not C)).
% mkaxiom(notimpfalse, bool(A) and not A => A = false).

postulate antintro === A => (B => A).

% mkaxiom(imptrans, (A => (B => C)) => ((A => B) => (A => C))).
% mkaxiom(negax, (not A => B) => ((not A => not B) => A)).
% mkaxiom(eq_cases, bool(A) and bool(B) => (A = B) = ((A => B) and (B => A))).

rerun(r:mkinstex).


%% Some additional postulates/theorems for the 'r' theory.
%% (these are all taken from the intro. to logic in Ian Hayes:
%%  'Specification Case Studies', Prentice-Hall, 1987).

rerun(r:and_assoc).
rerun(r:or_assoc).


postulate all_nfi
=== (all x N) <=> N
 :- x not_free_in N.

postulate ex_nfi
=== (ex x N) <=> N
 :- x not_free_in N.

postulate imp_reverse_not
=== (A => B) <=> (not B => not A).


%% Distributivity of 'and'.
%% -----------------------
postulate and_dist_or_l
=== A and (B or C) <=> (A and B) or (A and C).

postulate and_dist_or_r
=== (A or B) and C <=> (A and C) or (B and C).


%% Distributivity of 'or'.
%% -----------------------
postulate or_dist_and_l
=== A or (B and C) <=> (A or B) and (A or C).

postulate or_dist_and_r
=== (A and B) or C <=> (A or C) and (B or C).


%% Distributivity of 'all'.
%% -----------------------

% Already proven:
%	theorem all_dist_and
%	theorem all_dist_and_l
%	theorem all_dist_and_r

postulate all_dist_or_l
=== (all x N or P) <=> N or (all x P)
 :- x not_free_in N.

postulate all_dist_or_r
=== (all x P or N) <=> (all x P) or N
 :- x not_free_in N.

postulate all_dist_imp_r
=== (all x P => N) <=> ((ex x P) => N)
 :- x not_free_in N.

postulate all_dist_imp_l
=== (all x N => P) <=> (N => (all x P))
 :- x not_free_in N.


%% Distributivity of 'ex'.
%% -----------------------

% theorem ex_dist_or
% === (ex x X or Y) <=> (ex x X) or (ex x Y).
rerun(r:ex_dist_or).

postulate ex_dist_and_l
=== (ex x N and P) <=> N and (ex x P)
 :- x not_free_in N.

postulate ex_dist_and_r
=== (ex x P and N) <=> (ex x P) and N
 :- x not_free_in N.

postulate ex_dist_imp_l
=== (ex x N => P) <=> N => (ex x P)
 :- x not_free_in N.

postulate ex_dist_imp_r
=== (ex x P => N) <=> (all x P) => N
 :- x not_free_in N.


%% Distributivity of 'not'.
%% ------------------------

% Already proven and rerun:
%	deMorganand    (should be not_dist_and ?)
%	deMorganor     (should be not_dist_or ?)

% theorem not_dist_all
% === not (all x P) <=> (ex x not P).
rerun(r:not_dist_all).

% theorem not_dist_ex
% === not (ex x P) <=> (all x not P).
rerun(r:not_dist_ex).


%% Additional properties of 'all'
%% ==============================

%% theorem allimptrans ===
%%   (all x (P => Q)) and (all x (Q => R)) => (all x (P => R)).
rerun(r:allimptrans).

%% theorem allall ===
%%   (all x (all y P)) <=> (all y (all x P)).
rerun(r:allall).

%% theorem oneptall ===
%%   (is_local x T) % and x not_free_in E
%%    => 
%%   ( (all x (x=E => T))
%%     <=>
%%     [E/x]*T
%%   ).
rerun(r:oneptall).


%% Additional properties of 'ex'
%% =============================

%% theorem ex_eq
%% === (ex y y = Z)   %% y not_free_in Z.
rerun(r:ex_eq).
