%% ERGO COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
%%
%% Copyright 1993 by The University of Queensland, Queensland 4072 Australia
%% 
%% 
%% Permission to use, copy and distribute this software for any
%% non-commercial purpose and without fee is hereby granted, provided
%% that the above copyright notice and this permission notice and
%% warranty disclaimer appear in all copies and in supporting
%% documentation, and that the name of the University of Queensland not
%% be used in advertising or publicity pertaining to distribution of
%% the software without specific, written prior permission.
%% 
%% Source code modifications are prohibited except where written 
%% agreement has been given in advance by the University of Queensland.
%% 
%% The University of Queensland disclaims all warranties with regard to
%% this software, including all implied warranties of merchantability
%% and fitness.  In no event shall the University of Queensland be
%% liable for any special, indirect or consequential damages or any
%% damages whatsoever resulting from loss of use, data or profits,
%% whether in an action of contract, negligence or other tortious
%% action, arising out of or in connection with the use or performance
%% of this software.
%% 
%% CVS dbms_int.ql,v 1.4 1993/12/10 02:18:38 marku Exp



/*
** The interepreter you get when you're not in a proof
*/


dbms_interface :- 
    repeat, 
      dbms_prompt(P),
      get_command(P, C),
      dbms_interface(C), 
    fail.


dbms_interface(C) :-
    dbms_command(C),
    once(C), !.

dbms_interface(C) :- 
    (in_macro -> writelist([C, '\n   -']) ; true),
    writeln('(unsuccessful)').


dbms_prompt(['\n\n[', CD, '] : ']) :-
        once(current_dir(CD) ; (CD = 'No theory')).

dbms_command(C) :-
    functor(C, F, N),
    once((sys_com(F/N) ;
          show_command(F/N) ;
	  tactic_command(F, N) ; 
          get_up(tactic_command, [F,N]))).


/* 
** commands to exit the proof tool
*/

bye :- save, exit(0).
abandon :- exit(0).


/*
** subvert the prover
*/

xyzzy :- interpreter.

